forceRequiredAddon("Weapon_Chainsaw");
forceRequiredAddon("Player_No_Jet");

swordImage.projectile.directDamage /= 2;
bowImage.projectile.directDamage /= 2;
gunImage.projectile.directDamage /= 2;
spearImage.projectile.directDamage /= 2;

function player::chainsawReset(){} // Don't let people get their body parts back.

package babyChainsawMassacre
{
	function chainsawProjectile::Damage(%this, %obj, %col, %fade, %pos, %normal)
	{
		parent::Damage(%this, %obj, %col, %fade, %pos, %normal);
		
		%jumpDisability = false;
		%walkDisability = 0;
		%crawlDisability = 0;
		
		if(!%col.isNodeVisible("rShoe") && !%col.isNodeVisible("rPeg"))
		{
			%jumpDisability = true;
			%walkDisability += 3;
			%crawlDisability += 0.2;
		}
		
		if(!%col.isNodeVisible("lShoe") && !%col.isNodeVisible("lPeg"))
		{
			%jumpDisability = true;
			%walkDisability += 3;
			%crawlDisability += 0.2;
		}
		
		if(!%col.isNodeVisible("rArm") && !%col.isNodeVisible("rArmSlim"))
		{
			%walkDisability += 0.50;
			%crawlDisability += 0.35;
			%col.hideNode("rHand");
			%col.hideNode("rHook");
		}
		
		if(!%col.isNodeVisible("lArm") && !%col.isNodeVisible("lArmSlim"))
		{
			%walkDisability += 0.50;
			%crawlDisability += 0.35;
			%col.hideNode("lHand");
			%col.hideNode("lHook");
		}
		
		if(!%col.isNodeVisible("rHand") && !%col.isNodeVisible("rHook"))
		{
			%walkDisability += 0.25;
			%crawlDisability += 0.35;
			%col.weaponDisabled = true;
			%col.unMountImage(0);
			%col.mountSlotDisabled[0] = true;
		}
		
		if(!%col.isNodeVisible("lHand") && !%col.isNodeVisible("lHook"))
		{
			%walkDisability += 0.25;
			%crawlDisability += 0.35;
			%col.lightDisabled = true;
			%col.unMountImage(1);
			%col.mountSlotDisabled[1] = true;
		}
		
		if(!%col.isNodeVisible("headSkin"))
		{
			%col.damage(%obj, %pos, 100, %this.directDamageType);
		}
		
		%data = %col.getDatablock();
		
		%col.isDamaged = true;
		%col.jumpDisability = %jumpDisability;
		if(%col.jumpDisability && %data != nameToID("NoJumpPlayer"))
			%col.setDatablock(nameToID("NoJumpPlayer"));
	
		%col.setMaxForwardSpeed(%data.maxForwardSpeed - %walkDisability);
		%col.setMaxSideSpeed(%data.maxSideSpeed - %walkDisability);
		%col.setMaxBackwardSpeed(%data.maxBackwardSpeed - %walkDisability);
		%col.setMaxCrouchForwardSpeed(%data.maxForwardCrouchSpeed - %walkDisability);
		%col.setMaxCrouchSideSpeed(%data.maxSideCrouchSpeed - %walkDisability);
		%col.setMaxCrouchBackwardSpeed(%data.maxBackwardCrouchSpeed - %walkDisability);
	}
	
	function gameConnection::applyBodyParts(%this)
	{
		if(%this.player.isDamaged)
			return;
		
		parent::applyBodyParts(%this);
	}
	
	function Armor::onTrigger(%this, %player, %slot, %val)
	{
		if(%player.jumpDisability == true && %slot == 2)
		{
			%player.client.centerPrint("You're too injured to jump!", 2);
			return;
		}
		
		return parent::onTrigger(%this, %player, %slot, %val);
	}
	
	function player::mountImage(%this, %image, %slot)
	{
		if(%this.mountSlotDisabled[%slot])
		{
			%this.client.centerPrint("You can't hold that, your hand is missing!", 3);
			return;
		}
		
		parent::mountImage(%this, %image, %slot);
	}
	
	function minigameSO::reset(%this, %client)
	{
		if(%this == $defaultMinigame)
		{
			%count=brickgroup_888888.getcount();for(%i=0;%i<%count;%i++)brickgroup_888888.getobject(%i).respawn();
			%this.schedule(5000, selectBaby, 0);
		}
		
		cancel(%this.playerChecksSchedule);
		%this.distanceCheck = 5;
		
		%this.playerChecksSchedule = %this.schedule(60000, playerChecks);
		
		return parent::reset(%this, %client);
	}
	
	function gameConnection::onClientLeaveGame(%this)
	{
		if(isObject(%client.player))
			if(%this.player.isBaby && %this.player.getDamageState() $= "Enabled")
				%this.minigame.selectBaby();
		return parent::onClientLeaveGame(%this);
	}
	
	function baby::onDisabled(%this, %obj, %slotQuestionMark)
	{
		if(isObject(%obj.client.minigame))
			%obj.client.minigame.distanceCheck = 0;
		
		parent::onDisabled(%this, %obj, %slotQuestionMark);
	}
};
activatePackage(babyChainsawMassacre);

function minigameSO::playerChecks(%this)
{
	%maxDistance = 50 * %this.distanceCheck;
	%this.distanceCheck--;
	
	for(%i = 0; %i < %this.numMembers; %i++)
	{
		if(!isObject(%this.member[%i].player))
			continue;
		
		if(vectorDist(%this.member[%i].player.getPosition(), "0 0 0") > %maxDistance)
		{
			%this.member[%i].player.kill();
			// %this.chatMessageAll(getRandomDeathCause(%this.member[%i].name));
			announce(getRandomDeathCause(%this.member[%i].name));
		}
	}
	
	%this.playerChecksSchedule = %this.schedule(30000, playerChecks);
}

function minigameSO::selectBaby(%this, %iteration)
{
	if(%iteration > 20)
	{
		%this.reset(0);
		return;
	}
	
	%select = %this.member[getRandom(%this.numMembers) - 1];
	
	if(!isObject(%select.player))
	{
		%this.selectBaby(%iteration + 1);
		return;
	}
	
	if(%select.player.getDamageState $= "Disabled")
	{
		%this.selectBaby(%iteration + 1);
		return;
	}
	
	if(%select == $lastBaby && %iteration < 10)
	{
		%this.selectBaby(%iteration + 1);
		return;
	}
	
	$lastBaby = %select;
	%select.player.makeBaby();
	%this.chatMsgAll("\c4" @ %select.name SPC "\c6is the baby! Run!", %select);
}

function player::makeBaby(%this)
{
	%this.setDatablock(baby);
	%this.isBaby = true;
	%this.addItem(nameToID("chainsawItem"), %this.client);
	%this.setScale("0.4 0.4 0.5");
}

$deathCause[$totalDeathCauses++] = "NAME tripped and fell.";
$deathCause[$totalDeathCauses++] = "NAME was massacred by non-baby humans.";
$deathCause[$totalDeathCauses++] = "NAME was slashed to pieces by a hoard of cats.";
$deathCause[$totalDeathCauses++] = "NAME died of old age.";
$deathCause[$totalDeathCauses++] = "NAME was eaten by a velociraptor.";
$deathCause[$totalDeathCauses++] = "NAME was dragged into an ant-hill.";
$deathCause[$totalDeathCauses++] = "Some birds thought NAME looked tasty.";
$deathCause[$totalDeathCauses++] = "NAME died of bubonic plague.";
$deathCause[$totalDeathCauses++] = "NAME spontaneously combusted.";
$deathCause[$totalDeathCauses++] = "NAME died of dysentery.";
$deathCause[$totalDeathCauses++] = "NAME didn't check himself therefore he wrecked himself.";
$deathCause[$totalDeathCauses++] = "NAME dropped a bad batch of shrooms";
$deathCause[$totalDeathCauses++] = "NAME has been removed for further scientific experimentation.";
$deathCause[$totalDeathCauses++] = "NAME died of chronic fiddle-diddle.";
$deathCause[$totalDeathCauses++] = "NAME didn't see it coming.";
$deathCause[$totalDeathCauses++] = "NAME tasted justice. Shovel justice.";
$deathCause[$totalDeathCauses++] = "NAME was skinned by a gorefast.";
$deathCause[$totalDeathCauses++] = "NAME died of self-induced suffocation.";
$deathCause[$totalDeathCauses++] = "NAME died in a freak masturbation incident.";
$deathCause[$totalDeathCauses++] = "NAME was a little coward, and died like one.";
$deathCause[$totalDeathCauses++] = "NAME was viciously gored by a pack of wild puppies.";
$deathCause[$totalDeathCauses++] = "NAME was killed by Ender Dragon.";
$deathCause[$totalDeathCauses++] = "NAME didn't look both ways before brushing their shoelaces.";
$deathCause[$totalDeathCauses++] = "NAME got 360 noscoped.";
$deathCause[$totalDeathCauses++] = "NAME didn't equip Mina's talisman.";

function getRandomDeathCause(%name)
{
	%string = "\c0" @ $deathCause[getRandom(1, $totalDeathCauses)];
	%string = strReplace(%string, "NAME", "\c5" @ %name @ "\c0");
	
	return %string;
}

datablock playerData(noJumpPlayer : PlayerNoJet)
{
	jumpForce = 0;
	uiname = "No-jump player";
};

datablock playerData(baby : PlayerNoJet)
{
	uiname = "Baby";
	maxDamage = 300;
	
	maxForwardSpeed = 20;
	maxSideSpeed = 15;
	maxBackwardSpeed = 12;
	maxForwardCrouchSpeed = 10;
	maxSideCrouchSpeed = 9;
	maxBackwardCrouchSpeed = 7;
};